
/**
 * Methodenbox der Turtle
 * 
 * @author Klaus Reinold
 * @version 1.0
 */
public class Methodenbox
{
    private Turtle t;

    /**
     * Konstruktor für Objekte der Klasse Methodenbox
     */
    public Methodenbox()
    {
        t = new Turtle();
        setzeWartezeit(5);
    }

    /**
     * Methode zum Gehen
     */
    public void gehe(double schritte)
    {
        t.Gehen(schritte);
    }

    /**
     * Methode zum Drehen
     */
    public void drehe(int grad)
    {
        t.Drehen(grad);
    }

    public void zeichneKreis(int radius)
    {
        t.KreisZeichnen(radius);
    }
    
    /**
     * Methode zum Stiftheben
     */
    public void hebeStift()
    {
        t.StiftHeben();
    }   

    /**
     * Methode zum Stiftsenken
     */
    public void senkeStift()
    {
        t.StiftSenken();
    }  

    /**
     * Methode zum Farbe setzen
     * @param r Rotanteil 0..255
     * @param g Grünanteil 0..255
     * @param b Blauanteil 0..255
     */
    public void setzeStiftfarbe(int r, int g, int b)
    {
        t.StiftfarbeSetzen(r, g, b);
    }  

    /**
     * Setzt die Wartezeit auf einen bestimmten Wert.
     * @param wartezeit Wartezeit nach Ausführung von gehe und drehe
     */
    public void setzeWartezeit(int wartezeit)
    {
        if(wartezeit > 0)
        {
            t.LangsamSetzen();
            t.WartezeitSetzen(wartezeit);
        }
        else
        {
            t.SchnellSetzen();
        }
    }
}