import java.util.ArrayList;
/**
 * AlgoWrapper für Kapitel 1, Aufgabe 2 - Türme von Hanoi
 * 
 * @author Klaus Reinold 
 * @version 1.0
 */
public class Methodenbox
{
    Stapel schiff1Stapel, rampeStapel, schiff2Stapel;
    Kran k;
    Spielstein s1, s2, s3;
    /**
     * Konstruktor für Objekte der Klasse AlgoWrapper
     */
    public Methodenbox()
    {
        schiff1Stapel = new Stapel(1);
        rampeStapel = new Stapel(2);
        schiff2Stapel = new Stapel(3);

        k = new Kran(schiff1Stapel, rampeStapel, schiff2Stapel);

        s1 = new Spielstein(50);
        schiff1Stapel.Hinzufügen(s1);
        s2 = new Spielstein(40);
        schiff1Stapel.Hinzufügen(s2);
        s3 = new Spielstein(30);
        schiff1Stapel.Hinzufügen(s3);

        Dreieck schiff1Bug = new Dreieck();
        schiff1Bug.PositionSetzen(70, 400);
        schiff1Bug.GrößeSetzen(20, 20);
        schiff1Bug.Drehen(180);
        schiff1Bug.FarbeSetzen("orange");

        Rechteck schiff1Rumpf = new Rechteck();
        schiff1Rumpf.PositionSetzen(70, 400);
        schiff1Rumpf.GrößeSetzen(60, 20);
        schiff1Rumpf.FarbeSetzen("orange");

        Dreieck schiff1Heck = new Dreieck();
        schiff1Heck.PositionSetzen(130, 400);
        schiff1Heck.GrößeSetzen(20, 20);
        schiff1Heck.Drehen(180);
        schiff1Heck.FarbeSetzen("orange");

        Rechteck rampe = new Rechteck();
        rampe.PositionSetzen(170, 400);
        rampe.GrößeSetzen(60, 20);
        rampe.FarbeSetzen("schwarz");

        Dreieck schiff2Bug = new Dreieck();
        schiff2Bug.PositionSetzen(270, 400);
        schiff2Bug.GrößeSetzen(20, 20);
        schiff2Bug.Drehen(180);
        schiff2Bug.FarbeSetzen("gelb");

        Rechteck schiff2Rumpf = new Rechteck();
        schiff2Rumpf.PositionSetzen(270, 400);
        schiff2Rumpf.GrößeSetzen(60, 20);
        schiff2Rumpf.FarbeSetzen("gelb");

        Dreieck schiff2Heck = new Dreieck();
        schiff2Heck.PositionSetzen(330, 400);
        schiff2Heck.GrößeSetzen(20, 20);
        schiff2Heck.Drehen(180);
        schiff2Heck.FarbeSetzen("gelb");

    }

    void Links()
    {
        k.Links();
    }

    void Rechts()
    {
        k.Rechts();
    }

    void Runter()
    {
        k.Runter();
    }

    void Hoch()
    {
        k.Hoch();
    }

    void Zugreifen()
    {
        k.Zugreifen();
    }

    void Loslassen()
    {
        k.Loslassen();
    }

    private class Spielstein
    {
        int stapel, höhe, breite;
        Rechteck symbol;

        Spielstein(int breiteNeu)
        {
            stapel = 1;
            höhe = 0;
            breite = breiteNeu; 
            symbol = new Rechteck();
            symbol.GrößeSetzen(breite, 20);
        }

        void PositionSetzen(int stapel, int höhe)
        {
            if(höhe != 10)
            {
                symbol.PositionSetzen(stapel*100-breite/2, 400-höhe*20);
            }
            else
            {
                symbol.PositionSetzen(stapel*100-breite/2, 30);
            }
        } 

        int BreiteGeben()
        {
            return breite;
        }

    }

    private class Stapel
    {
        ArrayList<Spielstein> containerStapel;
        int position;

        Stapel(int positionNeu)
        {
            position = positionNeu;
            containerStapel = new ArrayList<Spielstein>();
        }

        boolean ContainerPasst(Spielstein s)
        {
            if(!containerStapel.isEmpty())
            {
                if(containerStapel.get(0).BreiteGeben()<s.BreiteGeben())
                {
                    System.out.println("Größere Container dürfen nicht auf kleineren liegen.");
                    return false;
                }
                return true;
            }
            else
            {
                return true;
            }
        }

        void Hinzufügen(Spielstein s)
        {

            containerStapel.add(0, s);
            s.PositionSetzen(position, containerStapel.size());
        }

        Spielstein Entfernen()
        {
            if(containerStapel.isEmpty())
            {
                System.out.println("von einem leeren Stapel kann nichts entfernt werden");
                return null;
            }
            else
            {
                return containerStapel.remove(0);
            }
        }

        int PositionGeben()
        {
            return position;
        }

        int HöheGeben()
        {
            return containerStapel.size();
        }
    }

    private class Kran
    {

        boolean istOben;
        Spielstein s;
        Rechteck kranSymbol;
        Stapel s1, s2, s3, aktStapel;

        Kran(Stapel s1Neu, Stapel s2Neu, Stapel s3Neu)
        {
            s1 = s1Neu;
            s2 = s2Neu; 
            s3 = s3Neu;

            istOben = true;
            kranSymbol = new Rechteck();
            kranSymbol.GrößeSetzen(100, 20);
            kranSymbol.FarbeSetzen("schwarz");
            PositionSetzen(s1, istOben);

            s = null;
            Pause();
        }

        void PositionSetzen(Stapel s, boolean istObenNeu)
        {
            aktStapel = s;
            istOben = istObenNeu;
            if(istOben)
            {
                kranSymbol.PositionSetzen(aktStapel.PositionGeben()*100-50, 30);
                if(this.s != null)
                {
                    System.out.println(aktStapel);
                    System.out.println(this.s);
                    this.s.PositionSetzen(aktStapel.PositionGeben(), 10); 
                }
            }
            else
            {
                if(this.s != null)
                {
                    this.s.PositionSetzen(aktStapel.PositionGeben(), aktStapel.HöheGeben()+1);

                }
                if(aktStapel.HöheGeben() == 0)
                {
                    kranSymbol.PositionSetzen(aktStapel.PositionGeben()*100-50, 400-aktStapel.HöheGeben()*20-20);
                }
                else
                {   if (this.s != null)
                    {
                        kranSymbol.PositionSetzen(aktStapel.PositionGeben()*100-50, 400-aktStapel.HöheGeben()*20-20);
                    }
                    else
                    {
                        kranSymbol.PositionSetzen(aktStapel.PositionGeben()*100-50, 400-aktStapel.HöheGeben()*20);
                    }
                }
            }

            Pause();
        }

        void Hoch()
        {
            if(istOben)
            {
                System.out.println("Kran ist schon oben");

            }
            else
            {
                System.out.println("Kran nach oben");
                PositionSetzen(aktStapel, true);
            }
            Pause();
        }

        void Runter()
        {
            if(!istOben)
            {
                System.out.println("Kran ist schon unten");

            }
            else
            {
                System.out.println("Kran nach unten");
                PositionSetzen(aktStapel, false);
            }
            Pause();
        }

        void Links()
        {
            if(!istOben)
            {
                System.out.println("Kran ist unten, kann nicht nach links bewegt werden");
            }
            else
            {
                if(aktStapel.PositionGeben()==1)
                {
                    System.out.println("Kran ist schon ganz links, geht nicht weiter!");
                }
                else
                {
                    if(aktStapel.PositionGeben()==2)
                    {
                        System.out.println("Kran geht zu Stapel 1");
                        PositionSetzen(s1, true);
                    }
                    else
                    {
                        System.out.println("Kran geht zu Stapel 2");
                        PositionSetzen(s2, true);
                    }              
                }
            }
            Pause();
        }

        void Rechts()
        {
            if(!istOben)
            {
                System.out.println("Kran ist unten, kann nicht nach rechts bewegt werden");
            }
            else
            {
                if(aktStapel.PositionGeben()==3)
                {
                    System.out.println("Kran ist schon ganz rechts, geht nicht weiter!");
                }
                else
                {
                    if(aktStapel.PositionGeben()==2)
                    {
                        System.out.println("Kran geht zu Stapel 3");
                        PositionSetzen(s3, true);
                    }
                    else
                    {
                        System.out.println("Kran geht zu Stapel 2");
                        PositionSetzen(s2, true);
                    }              
                }
            }
            Pause();
        }

        void Zugreifen()
        {
            if(istOben)
            {
                System.out.println("Kran ist oben, kann nicht zugreifen");
            }        
            else 
            {
                if(aktStapel.HöheGeben()==0)
                {
                    System.out.println("Stapel ist leer");
                }
                else
                {
                    if(s != null)
                    {
                        System.out.println("Es wird bereits ein Container transportiert");
                    }
                    else
                    {
                        s = aktStapel.Entfernen();
                    }
                }
            }
            Pause();
        }

        void Loslassen()
        {
            if(istOben)
            {
                System.out.println("Kran ist oben, kann nicht loslassen");
            }        
            else 
            {
                if(s == null)
                {
                    System.out.println("Es wird kein Container transportiert");
                }
                else
                {
                    if(aktStapel.ContainerPasst(s))
                    {
                        System.out.println("Container wird abgelegt");
                        aktStapel.Hinzufügen(s);
                        s = null;
                    }

                }
            }
            Pause();
        }

        void Pause()
        {
           long ende = System.currentTimeMillis() + 500;
           while (System.currentTimeMillis() < ende)
           {
                try
                {
                    Thread.sleep(ende - System.currentTimeMillis());
                }
                catch (Exception e){};
           }
        }

    }

}

